SystemOrganization addCategory: #'tODE-Views'!

Notification subclass: #TOAbortCommand
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TORenderer methodsFor: '*tode-views' stamp: 'dkh 6/22/2011 15:07'!
linkedItemsFor: aCollection withViewerDo: aBlock
	| previous first viewer |
	previous := nil.
	first := viewer := TOLinkedView new.
	aCollection
		do: [ :each | 
			viewer object: each.
			previous ifNotNil: [ previous next: viewer ].
			viewer previous: previous.
			previous := viewer.
			aBlock value: each value: viewer.
			viewer := TOLinkedView new ].
	^ first! !

TORenderer subclass: #TOView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

TOView subclass: #TOLinkedView
	instanceVariableNames: 'next previous parent parentLabel label itemLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

TOLinkedView subclass: #TOItemView
	instanceVariableNames: 'collectionIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOItemView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:56'!
collection
	^ self parent! !

!TOItemView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:56'!
collection: aCollection
	self parent: aCollection! !

!TOItemView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:56'!
collectionIndex
	^ collectionIndex! !

!TOItemView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:56'!
collectionIndex: anInteger
	collectionIndex := anInteger! !

!TOItemView methodsFor: 'rendering' stamp: 'dkh 6/22/2011 14:56'!
renderViewContentOn: html spec: aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	self
		renderButton: [ :s | 
			self currentSession push: self collection selecting: #view.
			main updateCenterSideHistory: s ]
		label: self collection label
		on: html.
	html break.
	self previous isNil
		ifTrue: [ html text: '<<' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					self collection selectedItemIndex: self previous collectionIndex.
					self currentSession push: self previous selecting: #view.
					main updateCenterSideHistory: s ]
				label: '<<'
				on: html ].
	html text: ' ' , self collectionIndex printString , ' of ' , self collection collection size printString , ' '.
	self next isNil
		ifTrue: [ html text: '>>' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					self collection selectedItemIndex: self next collectionIndex.
					self currentSession push: self next selecting: #view.
					main updateCenterSideHistory: s ]
				label: '>>'
				on: html ].
	html horizontalRule.
	self collection itemRenderBlock value: self object value: html value: main! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 15:18'!
itemLabel
	itemLabel ifNil: [ ^ '' ].
	^ itemLabel! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 15:18'!
itemLabel: aString
	itemLabel := aString! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 15:18'!
label
	label ifNil: [ ^ '' ].
	^ label! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:53'!
label: aString
	label := aString! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:41'!
next

^next! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:41'!
next: aTOLinkedView

next := aTOLinkedView! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:55'!
parent
	^ parent! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:54'!
parent: anObject
	parent := anObject! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:53'!
parentLabel
	parentLabel ifNil: [ ^ self parent printString ].
	^ parentLabel! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:53'!
parentLabel: aString
	parentLabel := aString! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:41'!
previous

^previous! !

!TOLinkedView methodsFor: 'accessing' stamp: 'dkh 6/22/2011 14:42'!
previous: aTOLinkedView

previous := aTOLinkedView! !

!TOLinkedView methodsFor: 'rendering' stamp: 'dkh 6/22/2011 15:53'!
renderViewContentOn: html spec: aTOTabSpec main: main
	self frame: aTOTabSpec frame.
	self parent
		ifNotNil: [ 
			self
				renderButton: [ :s | 
					self currentSession push: self parent selecting: #view.
					main updateCenterSideHistory: s ]
				label: self parentLabel
				on: html.
			html break ].
	self previous isNil
		ifTrue: [ html text: '<<' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					self currentSession push: self previous selecting: #view.
					main updateCenterSideHistory: s ]
				label: '<<'
				on: html ].
	html text: ' ' , self label , ' '.
	self next isNil
		ifTrue: [ html text: '>>' ]
		ifFalse: [ 
			self
				renderButton: [ :s | 
					self currentSession push: self next selecting: #view.
					main updateCenterSideHistory: s ]
				label: '>>'
				on: html ].
	html horizontalRule.
	self
		renderLink: [ :s | 
			self currentSession push: self object selecting: #view.
			main updateCenterSideHistory: s ]
		with: self itemLabel
		on: html! !

TOView subclass: #TOSharedClassState
	instanceVariableNames: 'selectedSuperclass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 6/2/2011 03:45'!
renderSuperclassHeading: aClass on: html main: main
	self
		renderSuperclassHeading: aClass
		renderName: [:cl | html strong: cl name ]
		whenClicked: [self selectedSuperclassChanged]
		on: html
		main: main.

! !

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 5/26/2011 20:55'!
renderSuperclassHeading: aClass renderName: renderNameBlock on: html main: main
	self
		renderSuperclassHeading: aClass
		renderName: renderNameBlock
		whenClicked: [ self selectedSuperclassChanged ]
		on: html
		main: main! !

!TOSharedClassState methodsFor: 'rendering' stamp: 'dkh 8/2/2011 14:14'!
renderSuperclassHeading: aClass renderName: renderNameBlock whenClicked: aBlock on: html main: main
	html text: 'Superclasses: '.
	aClass allSuperclasses reversed
		do: [ :supClass | 
			supClass == self selectedSuperclass
				ifTrue: [ renderNameBlock value: supClass ]
				ifFalse: [ 
					self
						renderIntraPageLink: [ :s | 
							self selectedSuperclass: supClass.
							aBlock value.
							main updateCenterSideHistory: s ]
						with: [ renderNameBlock value: supClass ]
						on: html ].
			html text: '->' ].
	self selectedSuperclass == nil
		ifTrue: [ renderNameBlock value: aClass ]
		ifFalse: [ 
			self
				renderIntraPageLink: [ :s | 
					self selectedSuperclass: nil.
					aBlock value.
					main updateCenterSideHistory: s ]
				with: [ renderNameBlock value: aClass ]
				on: html ].
	html text: ' [ '.
	aClass isMeta
		ifTrue: [ 
			self
				renderIntraPageLink: [ :s | 
					self currentSession push: aClass theNonMetaClass selecting: #classBrowser.
					main updateCenterSideHistory: s ]
				with: [html text: 'instance']
				on: html ]
		ifFalse: [ 
			self
				renderIntraPageLink: [ :s | 
					self currentSession push: aClass class selecting: #classBrowser.
					main updateCenterSideHistory: s ]
				with: [html text: 'class']
				on: html ].
	html text: ' ]'.! !

!TOSharedClassState methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass
	^ selectedSuperclass! !

!TOSharedClassState methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:11'!
selectedSuperclass: anObject
	^ selectedSuperclass := anObject! !

!TOSharedClassState methodsFor: 'events' stamp: 'dkh 5/29/2011 10:15'!
selectedSuperclassChanged
	#(#methodSourceBrowser #methodCategoryBrowser #classBrowser)
		do: [ :id | frame properties at: id ifPresent: [ :view | view selectedSuperclassChanged ] ]! !

TOView subclass: #TOSidebar
	instanceVariableNames: 'specLabel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'tODE-Views'!

!TOSidebar methodsFor: 'accesseing' stamp: 'dkh 6/25/2011 04:12'!
defaultSpecLabel
	self subclassResponsibility! !

!TOSidebar methodsFor: 'rendering' stamp: 'dkh 6/25/2011 04:35'!
renderContentOn: html main: main
	"subclasses should override to supply custom rendering"

	self renderViewContentOn: html main: main! !

!TOSidebar methodsFor: 'accesseing' stamp: 'dkh 6/25/2011 04:09'!
specLabel
	specLabel ifNil: [ specLabel := self defaultSpecLabel ].
	^ specLabel! !

!TOSidebar methodsFor: 'accesseing' stamp: 'dkh 6/25/2011 04:10'!
specLabel: aSymbol
	specLabel := aSymbol ! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/22/2011 17:25'!
renderClassHeading: aClass on: html main: main

	self renderSuperclassHeading: aClass on: html main: main.
! !

!TOView methodsFor: 'rendering' stamp: 'dkh 5/26/2011 13:53'!
renderSuperclassHeading: aClass on: html main: main
	self sharedClassState
		renderSuperclassHeading: aClass
		on: html
		main: main! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass
	^self sharedClassState selectedSuperclass! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/24/2011 01:25'!
selectedSuperclass: anObject
	self sharedClassState selectedSuperclass: anObject! !

!TOView methodsFor: 'events' stamp: 'dkh 5/26/2011 13:47'!
selectedSuperclassChanged! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 09:09'!
sharedClassState
	^ self frame properties
		at: #sharedClassState
		ifAbsent: [ 
			self frame properties
				at: #sharedClassState
				put:
					((TOSharedClassState new)
						object: self object;
						frame: self frame;
						yourself) ]! !

!TOView methodsFor: 'accessing' stamp: 'dkh 5/27/2011 14:43'!
textAreaColumns: text

	| lineWidth tab |
	lineWidth := 0.
	tab := Character tab.
	text linesDo: [:line | | tabs |
		tabs := 0.
		line do: [:char | char = tab ifTrue: [ tabs := tabs + 5 ]].
		lineWidth := lineWidth max: (line size + tabs)].
	^lineWidth! !

!TOView methodsFor: 'accessing' stamp: 'dkh 6/17/2011 15:57'!
textAreaRows: text

	| lineCount |
	lineCount := 0.
	text linesDo:[:line | lineCount := lineCount + 1 ].
	^lineCount+1! !

!TOView methodsFor: 'accessing' stamp: 'dkh 05/27/2011 11:46'!
theClass

	^self selectedSuperclass ifNil: [ self actualClass ]! !
